<?php
/*
	ext_Tx_SpiderIndexing
	@qSearchWord
	@qSearchType
	@rowsLimit
	@info_page_content_nice // [решил убрать пока - не актуально] обрезает контен, подсвечивает найденные данные, вырезает "|||"
	return $rows;
*/
require_once ( t3lib_extMgm::extPath('phptemplate') . "plugins/function.str.php" );
function phptemplate_plugin_ext_Tx_SpiderIndexing_getEasySearchResult($self, $qSearchWord = "", $qSearchType = "", $rowsLimit = 7, $info_page_content_nice = 1) {

	if (!t3lib_extMgm::isLoaded('spiderindexing')) {
		return tx_phptemplate_error_wrap("Extension \"spiderindexing\" not loaded for plugin ext_Tx_SpiderIndexing_...()!");
	}
	
	if (empty($qSearchType)) {
		$qSearchType = "pTitle";
	}

	if ($rowsLimit <= NULL) {
		$rowsLimit = 7;
	}
	
	
            // Обычный поиск - до 3-ех символов (поиск только по заголовкам и meta-данным) 
        // $qSearchWord = $GLOBALS['_POST']['tx_indexedsearch']['sword']; 
        $rows = array();
		$qSearchWord = trim($qSearchWord);
		if (!empty($qSearchWord)){ 
			if ($qSearchType == "pTitle") {
                  
                $qSearchWord = (mb_strlen($qSearchWord, 'UTF-8') <= 1) ? $qSearchWord . "%" : "%" . $qSearchWord . "%"; 
                $qSearchWord = str_replace (' ','%', $qSearchWord); 
                $rows = DB::run()->table('tx_spiderindexing_content') 
                                ->select('telem,info_page_title,info_page_url') 
								// ->whereRaw(" ( ") 
                                ->where('info_page_title', 'LIKE', $qSearchWord) // ->whereRaw(" OR ") 
								// ->where('info_page_meta_description', 'LIKE', $qSearchWord)->whereRaw(" OR ") 
								// ->where('info_page_meta_keywords', 'LIKE', $qSearchWord) 
								// ->whereRaw(" ) ") 
                                ->limit($rowsLimit) // 7
                                ->exec(); 
  
            } else { 
  
                    // Полнотекстовый поиск (от четырех символов) 
                /* 
                    В MySQL 4.0.1 возможен полнотекстовый поиск также и в логическом режиме с использованием модификатора IN BOOLEAN MODE.  
                    Полезной особенностью данного модификатора является оператор * (звездочка).  
                    Используя данный оператор в конструкции MATCH(`title`) AGAINST('про*' IN BOOLEAN MODE)  
                    мы получим совпадения для таких слов как "программа", "продукт", "прогресс" и так далее.  
                    Релевантность в логическом режиме равняется либо 0 (нет совпадения) либо 1 (есть совпадение). 
                */
					// До 4-ех символов обрабатывается через LIKE
				if (mb_strlen($qSearchWord, 'UTF-8') <= 4) {
					$rows = DB::run()->query("  
							SELECT *
							FROM `tx_spiderindexing_content` 
							WHERE 
								`info_page_content` LIKE :1
								AND hidden = 0 
								AND deleted=0 
							LIMIT :2
					")
					->bindParam(1, "%" . $qSearchWord . "%")
					->bindParam(2, intval($rowsLimit))
					->exec();
				} else {
					$rows = DB::run()->query("  
						SELECT telem,info_page_title,info_page_url,info_page_content, ( 
							MATCH(info_page_title) AGAINST(:1 IN BOOLEAN MODE) * 10 + 
							# MATCH(info_page_meta_keywords) AGAINST(:1 IN BOOLEAN MODE) * 7 + 
							# MATCH(info_page_meta_description) AGAINST(:1 IN BOOLEAN MODE) * 5 + 
							MATCH(info_page_content) AGAINST(:1 IN BOOLEAN MODE) 
						) AS `relev` 
						FROM tx_spiderindexing_content  
						WHERE  
						   ( MATCH(`info_page_title`) AGAINST(:1 IN BOOLEAN MODE) 
							OR 
							# MATCH(`info_page_meta_keywords`) AGAINST(:1 IN BOOLEAN MODE) 
							# OR 
							# MATCH(`info_page_meta_description`) AGAINST(:1 IN BOOLEAN MODE) 
							# OR 
							MATCH(`info_page_content`) AGAINST(:1 IN BOOLEAN MODE) 
							) AND hidden = 0 AND deleted=0 
						ORDER BY `relev` DESC  
						LIMIT :2 
					")
					->bindParam(1, str_replace(' ', '*', $qSearchWord) . "*")
					->bindParam(2, intval($rowsLimit))
					->exec(); 
				}
  
            } 
			
			if (count($rows) > 0) {
				// [idea] - пока решил отложить
				# foreach ($rows as $key => $value) {
				#	$rows[$key]['info_page_url_with_AddParameterOnSelectedResult'] 
				#	= $rows[$key]['info_page_url'] . "?=tx_spiderindexing[see_result]=" . rawurlencode($qSearchWord);
				# }
				if ($info_page_content_nice == 1) {
					foreach ($rows as $key => $value) {
						// $rows[$key]['info_page_content'] = htmlspecialchars($rows[$key]['info_page_content']); // кодируем в спец.символы html
						
							// Подсветка искомого, и краткий вывод как в гугл.
						$rows[$key]['info_page_content'] = str_replace("|||", " ", $rows[$key]['info_page_content']); // убираем соединитель (если на странице несколько тэгов <!--TYPO3SEARCH_begin-->
						$rows[$key]['info_page_content'] = phptemplate_plugin_ext_Tx_SpiderIndexing_getEasySearchResult_highlight_words( $self, $rows[$key]['info_page_content'], $qSearchWord );
						#$rows[$key]['info_page_content'] = phptemplate_plugin_ext_Tx_SpiderIndexing_getEasySearchResult_generate_regexp_from_query($rows[$key]['info_page_content'], $rows[$key]['info_page_content'], $qSearchWord);
						#$rows[$key]['info_page_content'] = $self->str($rows[$key]['info_page_content'], "truncate", 1000);
					}
				}
				return $rows;
			} else {
				return NULL;
			}
			
        } else {
			return NULL;
		}

}

	// function buildTeaserContent($content) {} Thenks  EXT: "ke_search"
function phptemplate_plugin_ext_Tx_SpiderIndexing_getEasySearchResult_highlight_words( &$self, $content, $qSearchWord ) {
	/*
	$temp1 = preg_replace('/W+/iu',' ',$qSearchWord);
	$temp = explode(" ", $temp);
	
	print "<pre>";
	print_r($temp1);
	exit();
	
	foreach ($temp as $k => $v) {
		$content = str_ireplace(trim($v), "<b>".trim($v)."</b>", $content);
		# $preg_search[] = "/".$v."/iu";
		# $preg_replace[] = "<b>".$v."</b>";
	}*/
		$swords = explode(" ", $qSearchWord);
		$resultChars = 200;
		$highlightSword = 1;
		
		if(is_array($swords) && count($swords)) {
			$amountOfSearchWords = count($swords);
			$content = strip_tags($content);
			// with each new searchword and all the croppings here the teaser for each word will become too small/short
			// I decided to add 20 additional letters for each searchword. It looks much better and is more readable
			$charsForEachSearchWord = ceil($resultChars / $amountOfSearchWords) + 20;
			$charsBeforeAfterSearchWord = ceil($charsForEachSearchWord / 2);
			$aSearchWordWasFound = FALSE;
			$isSearchWordAtTheBeginning = FALSE;
			foreach($swords as $word) {
				$word = ' ' . $word; // our searchengine searches for wordbeginnings
				$pos = stripos($content, $word);
				if($pos === FALSE) {
					// if the word was not found it could be within brakets => (searchWord)
					// so give it a second try
					$pos = stripos($content, trim($word));
					if($pos === FALSE) {
						continue;
					}
				}
				$aSearchWordWasFound = TRUE;

				// if searchword is the first word
				if($pos === 0) {
					$isSearchWordAtTheBeginning = TRUE;
				}

				// find search starting point
				$startPos = $pos - $charsBeforeAfterSearchWord;
				if($startPos < 0) $startPos = 0;

				// crop some words behind searchword
				$partWithSearchWord = substr($content, $startPos);
				$temp = $self->cObj->crop($partWithSearchWord, $charsForEachSearchWord . '|...|1');

				// crop some words before searchword
				// after last cropping our text is too short now. So we have to find a new cutting position
				($startPos > 10)? $length = strlen($temp) - 10: $length = strlen($temp);
				$teaserArray[] = $self->cObj->crop($temp, '-' . $length . '||1');
			}

			// When the searchword was found in title but not in content the teaser is empty
			// in that case we have to get the first x letters without containing any searchword
			if($aSearchWordWasFound === FALSE) {
				$teaser = $self->cObj->crop($content, $resultChars . '||1');
			} elseif($isSearchWordAtTheBeginning === TRUE) {
				$teaser = implode(' ', $teaserArray);
			} else {
				$teaser = '...' . implode(' ', $teaserArray);
			}

			// highlight hits?
			if ($highlightSword == 1) {
				$teaser = phptemplate_plugin_ext_Tx_SpiderIndexing_getEasySearchResult_highlightArrayOfWordsInContent($swords, $teaser);
			}
			return $teaser;
		} else {
			return $self->cObj->crop($content, $resultChars . '|...|1');
		}
	
    # $content = preg_replace($preg_search, $preg_replace, $content);
	# return $content; // return highlighted data
}

	// Thenks  EXT: "ke_search"
	/**
	 * Find and highlight the searchwords
	 *
	 * @param array $wordArray
	 * @param string $content
	 * @return string The content with highlighted searchwords
	 */
	function phptemplate_plugin_ext_Tx_SpiderIndexing_getEasySearchResult_highlightArrayOfWordsInContent($wordArray, $content) {
		if(is_array($wordArray) && count($wordArray)) {
			foreach($wordArray as $word) {
				$word = str_replace('/', '\/', $word);
				$word = htmlspecialchars($word);
				$content = preg_replace('/(' . $word . ')/iu','<span class="hit">\0</span>', $content);
			}
		}
		return $content;
	}

/*
function phptemplate_plugin_ext_Tx_SpiderIndexing_getEasySearchResult_Strip_text($data,$size,$elipse = true){
    $data = strip_tags($data);          
    if(mb_strlen($data, 'utf-8') > $size){
        $result = mb_substr($data,0,mb_strpos($data,' ',$size,'utf-8'),'utf-8');
            if(mb_strlen($result, 'utf-8') <= 0){
            $result = mb_substr($data,0,$size,'utf-8');
            $result = mb_substr($result, 0, mb_strrpos($result, ' ','utf-8'),'utf-8');;         
        }
        if($elipse) {
            $result .= "...";
        }
    }else{
    $result = $data;
    }
    return $result; 
}
*/
?>