<?php
/*
	recordStatus
	@table
	@recordId
*/
function phptemplate_plugin_recordStatus($self, $table = "tt_content", $recordId = 0) {
	if(isset($table) && isset($GLOBALS['TCA'][$table])){
		t3lib_div::loadTCA($table);
		$disableColumn 	= $GLOBALS['TCA'][$table]['ctrl']['enablecolumns']['disabled'];
		$deletedColumn 	= $GLOBALS['TCA'][$table]['ctrl']['delete'];
		$fieldSelect = array();
		
			if(!empty($disableColumn)){
				$fieldSelect[] = $disableColumn;
			}
	
			if(!empty($deletedColumn)){
				$fieldSelect[] = $deletedColumn;
			}
		
		$row = DB::run()->table($table)->select(implode(",", $fieldSelect))->where('uid', '=', $recordId)->disableEnableFieldsAll()->limit(1)->exec();
		
		if(!empty($deletedColumn) && $row[0][$deletedColumn] == 1){
			return '<span style="color: gray;">(Удален)</span>';
		} elseif (!empty($disableColumn) && $row[0][$disableColumn] == 1) {
			return '<span style="color: red;">(Выключен)</span>';	
		} else {
			return '<span style="color: green;">(Активен)</span>';
		}
	}
	return '???';
}

?>