<?php
/*
	@ L - единственный параметр, который принимает функция - это новый язык
	return - возвращяет url без языкового параметра
	вспомогательная функция - актуально для создания языковых переключателей [мультиязычные проекты]
*/
function phptemplate_plugin_urlChangeLangParameter($self, $L) {

	// QUERY_STRING
	//	$uParts = parse_url($GLOBALS);
	$additionalParams = explode("&", $GLOBALS['_SERVER']['QUERY_STRING']);
	$additionalParamsResult = "";
	foreach($additionalParams as $k => $v) {
		$v = explode("=", $v);
		if ($v[1] != NULL) {
			$additionalParamsResult .= "&" . $v[0] . "=" . $v[1];
		}
	}
		
		// Set L parameter
	$additionalParamsResult .= "&L=" . $L;
	
		// Get the typolink
	$tsConf = array(
		'parameter' => $GLOBALS['TSFE']->id,
		'additionalParams' => $additionalParamsResult,
		'useCacheHash' => ((isset($additionalParamsResult['cHash']))? 1 : 0),
		'returnLast' => 'url',
	);
	
	# $self->print_r($tsConf);
	return $self->cObj->typolink("", $tsConf);
}
?>